--
library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

entity CLKGEN is
	port (
		CLK50M		: in  std_logic;
		RSTN		: in  std_logic;
		CLK108MOUT	: out std_logic;
		CLK50MOUT	: out std_logic;
		CLK1SOUT	: out std_logic;
		LOCK_PLL	: out std_logic
	);
end CLKGEN;

architecture RTL of CLKGEN is

	component PLL108M is
		port (
			areset	: in  std_logic;
			inclk0	: in  std_logic;
			c0		: out std_logic;
			c1		: out std_logic;
			locked	: out std_logic
		);
	end component;

	signal aclr			: std_logic;
	signal lock_108m	: std_logic;

	signal clk50m_i		: std_logic;
	signal cnt_500m		: std_logic_vector(24 downto 0);
	signal cnt_1s		: std_logic;

begin

	U_PLL108M : PLL108M
	port map (
		areset	=> aclr,
		inclk0	=> CLK50M,
		c0		=> CLK108MOUT,
		c1		=> clk50m_i,
		locked	=> lock_108m
	);

	aclr <= not RSTN;

	process (clk50m_i,RSTN)
	begin
		if (RSTN = '0') then
			cnt_500m <= (others => '0');
		elsif (clk50m_i'event and clk50m_i = '1') then
			if (cnt_500m = 24999999) then
				cnt_500m <= (others => '0');
			else
				cnt_500m <= cnt_500m + 1;
			end if;
		end if;
	end process;

	process (clk50m_i,RSTN)
	begin
		if (RSTN = '0') then
			cnt_1s <= '0';
		elsif (clk50m_i'event and clk50m_i = '1') then
			if (cnt_500m = 24999999) then
				cnt_1s <= not cnt_1s;
			end if;
		end if;
	end process;

	CLK50MOUT <= clk50m_i;
	CLK1SOUT  <= cnt_1s;
	LOCK_PLL  <= lock_108m;

end RTL;
